using namespace std;
#include <iostream>
#include <stdlib.h>
#include "dizionario_chiuso.h"

void Cella::setlabel(tipoelem etichetta){
    label=etichetta;
}

tipoelem Cella::getlabel(){
    return label;
}

void Dizionario::creadizionario(){
    int i;
    for(i=0;i<MAX;i++){
        dizionario[i]=(NULL);
        stato[i]=0;
    }
}

/***
Gestione collisione con scansione lineare  
j: cursore cella con elemento a (se esiste)
c cursore prima cella vuota incontrata nella scansione
stato[j]=0 cella libera
stato[j]=1 cella cancellata
*/
void Dizionario::scandisci(tipoelem a,int &j,int &c){
    int i;
    boolean libero,trovato,esaurito;
    i=hash(a,MAX);// calcolo mediante funzione hash del punto inizio scansione
    j=c=i;
    libero=esaurito=trovato=false;//inizializzazione valori; 
    if (dizionario[j]!=NULL && dizionario[j]->getlabel()==0 && stato[j]==1){
       trovato==true;//ho trovato un elemento cancellato nella posizione della funzione hash
    }
    while ((!((libero)||(trovato)||(esaurito) ))){
        if (dizionario[j]!=NULL && dizionario[j]->getlabel()!=0){ 
/*getlabel restituisce il valore puntato dal puntatore se non si cancella con delete*/
            if(dizionario[j]->getlabel()==a) trovato=true;
            else{            
                j=(j+1) % MAX; // avanza nella scansione (se arriva alla fine riprende dall'inizio)
                if (i==j) esaurito=true;// se ho terminato la scansione
                }
        }else{
            c=j;
            libero=true;
        }
    }
}

boolean Dizionario::appartiene(tipoelem a){
    int j,c;
    scandisci(a,j,c);
    if ((dizionario[j]!=NULL) && (dizionario[j]->getlabel()==a)) return true;
    return false;        
}

void Dizionario::inserisci(tipoelem a){
    int j,c;
    scandisci(a,j,c);
    if (!appartiene(a)){
           if (dizionario[c]==NULL) dizionario[c]=new Cella;
           dizionario[c]->setlabel(a);
           stato[c]=0;
    }
    stampatutto();
}

void Dizionario::stampatutto(){
    cout<<"dizionario["<<MAX<<"]: {";
    for(int p=0;p<MAX;p++){
            if (p>0)cout<<"|";
            if (dizionario[p]!=NULL) cout<<dizionario[p]->getlabel();
            else cout<<dizionario[p];
    }
    cout<<"}"<<endl;
    cout<<"     stato["<<MAX<<"]: {";
    for(int p=0;p<MAX;p++){
            if (p>0)cout<<"|";
            cout<<stato[p];
    }
    cout<<"}"<<endl;
}

void Dizionario::cancella(tipoelem a){
    int j,c;
    scandisci(a,j,c);
    if (dizionario[j]!=NULL){
        if (dizionario[j]->getlabel()==a){ 
            stato[j]=1;
            dizionario[j]->setlabel(0);
        }
    }
    stampatutto();
}


